## aarnt-octopi.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(octopi VERSION 0.16.2 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_THREAD_PREFER_PTHREAD True)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

option(USE_QTERMWIDGET6 "Build with qtermwidget6 instead of qtermwidget5" ON)

add_subdirectory(helper)
add_subdirectory(notifier)
add_subdirectory(cachecleaner)
add_subdirectory(repoeditor)

if (USE_QTERMWIDGET6)
  find_package(Qt6 REQUIRED COMPONENTS Core Core5Compat Gui Network Xml Widgets LinguistTools Multimedia)
  find_package(qtermwidget6 REQUIRED)
else()
  find_package(Qt5 REQUIRED COMPONENTS Core Gui Network Xml Widgets LinguistTools Multimedia)
  find_package(qtermwidget5 REQUIRED)
endif()

find_package(alpm_octopi_utils REQUIRED)

set(CMAKE_AUTOMOC ON)

file(GLOB TS_FILES LIST_DIRECTORIES false "${CMAKE_CURRENT_LIST_DIR}/resources/translations/*.ts")
qt_add_translation(qmFiles ${TS_FILES})

set(src
    src/QtSolutions/qtsingleapplication.cpp
    src/QtSolutions/qtlocalpeer.cpp
    repoeditor/repoentry.cpp
    src/aurvote.cpp
    src/propertiestabwidget.cpp
    src/qaesencryption.cpp
    src/repoconf.cpp
    src/main.cpp
    src/mainwindow.cpp
    src/strconstants.cpp
    src/searchlineedit.cpp
    src/argumentlist.cpp
    src/settingsmanager.cpp
    src/package.cpp
    src/unixcommand.cpp
    src/wmhelper.cpp
    src/treeviewpackagesitemdelegate.cpp
    src/mainwindow_init.cpp
    src/mainwindow_transaction.cpp
    src/mainwindow_events.cpp
    src/mainwindow_help.cpp
    src/searchbar.cpp
    src/mainwindow_searchbar.cpp
    src/transactiondialog.cpp
    src/mainwindow_news.cpp
    src/mainwindow_refresh.cpp
    src/globals.cpp
    src/multiselectiondialog.cpp
    src/packagerepository.cpp
    src/model/packagemodel.cpp
    src/ui/octopitabinfo.cpp
    src/utils.cpp
    src/terminal.cpp
    src/pacmanexec.cpp
    src/optionsdialog.cpp
    src/packagetreeview.cpp
    src/termwidget.cpp
    src/alpmbackend.cpp)

set(header
    src/QtSolutions/qtsingleapplication.h
    src/QtSolutions/qtlocalpeer.h
    repoeditor/repoentry.h
    src/aurvote.h
    src/propertiestabwidget.h
    src/qaesencryption.h
    src/repoconf.h
    src/mainwindow.h
    src/strconstants.h
    src/searchlineedit.h
    src/argumentlist.h
    src/settingsmanager.h
    src/uihelper.h
    src/package.h
    src/unixcommand.h
    src/wmhelper.h
    src/treeviewpackagesitemdelegate.h
    src/searchbar.h
    src/transactiondialog.h
    src/globals.h
    src/multiselectiondialog.h
    src/packagerepository.h
    src/model/packagemodel.h
    src/ui/octopitabinfo.h
    src/utils.h
    src/terminal.h
    src/pacmanexec.h
    src/constants.h
    src/optionsdialog.h
    src/packagetreeview.h
    src/termwidget.h
    src/alpmbackend.h)

set(ui ui/mainwindow.ui ui/transactiondialog.ui ui/multiselectiondialog.ui ui/optionsdialog.ui)

set(qrc resources.qrc)

qt_wrap_ui(src ${ui})
qt_add_resources(src ${qrc})

add_executable(octopi ${src} ${header} ${qmFiles})
target_compile_definitions(octopi PRIVATE OCTOPI_EXTENSIONS ALPM_BACKEND QT_DEPRECATED_WARNINGS QT_USE_QSTRINGBUILDER QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_FROM_BYTEARRAY)

if (USE_QTERMWIDGET6)
  target_include_directories(octopi PRIVATE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${Qt6Core_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Xml_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS})
  target_link_libraries(octopi PRIVATE Qt6::Core Qt6::Gui Qt6::Network Qt6::Xml Qt6::Widgets Qt6::Multimedia qtermwidget6 alpm_octopi_utils)
else()
  target_include_directories(octopi PRIVATE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${Qt5Core_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS})
  target_link_libraries(octopi PRIVATE Qt5::Core Qt5::Gui Qt5::Network Qt5::Xml Qt5::Widgets Qt5::Multimedia qtermwidget5 alpm_octopi_utils)
endif()

file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/resources/images/octopi_green.png" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(RENAME "${CMAKE_CURRENT_BINARY_DIR}/octopi_green.png" "${CMAKE_CURRENT_BINARY_DIR}/octopi.png")
install(TARGETS octopi RUNTIME DESTINATION bin LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/octopi.desktop" DESTINATION share/applications)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/octopi.png" "${CMAKE_CURRENT_SOURCE_DIR}/resources/images/octopi_green.png" DESTINATION share/icons/gnome/32x32/apps)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/octopi.png" "${CMAKE_CURRENT_SOURCE_DIR}/resources/images/octopi_green.png"
        "${CMAKE_CURRENT_SOURCE_DIR}/resources/images/octopi_red.png" "${CMAKE_CURRENT_SOURCE_DIR}/resources/images/octopi_yellow.png" DESTINATION share/icons)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE" DESTINATION share/licenses/octopi)

=== cachecleaner/CMakeLists.txt ===
if (USE_QTERMWIDGET6)
  find_package(Qt6 REQUIRED COMPONENTS Core Network Xml Widgets LinguistTools)
else()
  find_package(Qt5 REQUIRED COMPONENTS Core Network Xml Widgets LinguistTools)
endif()

set(CMAKE_AUTOMOC ON)

file(GLOB TS_FILES LIST_DIRECTORIES false "${CMAKE_CURRENT_LIST_DIR}/resources/translations/*.ts")
qt_add_translation(qmFiles ${TS_FILES})

set(src 
    main.cpp
    cachecleaner.cpp
    packagegroupmodel.cpp
    ../src/strconstants.cpp
    ../src/qaesencryption.cpp
    ../src/unixcommand.cpp
    ../src/wmhelper.cpp
    ../src/terminal.cpp
    ../src/settingsmanager.cpp
    ../src/searchlineedit.cpp
    ../src/utils.cpp
    ../src/package.cpp
    ../src/QtSolutions/qtsingleapplication.cpp
    ../src/QtSolutions/qtlocalpeer.cpp
    #../src/QtSolutions/qtlockedfile.cpp
    ../src/QtSolutions/qtsinglecoreapplication.cpp)

set(header 
    cachecleaner.h
    packagegroupmodel.h
    ../src/strconstants.h
    ../src/qaesencryption.h
    ../src/unixcommand.h
    ../src/wmhelper.h
    ../src/terminal.h
    ../src/settingsmanager.h
    ../src/searchlineedit.h
    ../src/utils.h
    ../src/package.h
    ../src/QtSolutions/qtsingleapplication.h
    ../src/QtSolutions/qtlocalpeer.h
    #../src/QtSolutions/qtlockedfile.h
    ../src/QtSolutions/qtsinglecoreapplication.h)

set(ui ui/cachecleaner.ui)

set(qrc resources.qrc)

qt_wrap_ui(src ${ui})
qt_add_resources(src ${qrc})
    
add_executable(octopi-cachecleaner ${src} ${header} ${qmFiles})
target_compile_definitions(octopi-cachecleaner PRIVATE QT_USE_QSTRINGBUILDER QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_FROM_BYTEARRAY)

if (USE_QTERMWIDGET6)
  target_include_directories(octopi-cachecleaner PRIVATE ${CMAKE_CURRENT_BINARY_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/src/QtSolutions" ${Qt6Core_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Xml_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS})
  target_link_libraries(octopi-cachecleaner PRIVATE Qt6::Core Qt6::Network Qt6::Xml Qt6::Widgets)
else()
  target_include_directories(octopi-cachecleaner PRIVATE ${CMAKE_CURRENT_BINARY_DIR} "${CMAKE_CURRENT_SOURCE_DIR}/src/QtSolutions" ${Qt5Core_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS})
  target_link_libraries(octopi-cachecleaner PRIVATE Qt5::Core Qt5::Network Qt5::Xml Qt5::Widgets)
endif()

install(TARGETS octopi-cachecleaner RUNTIME DESTINATION bin LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/octopi-cachecleaner.desktop" DESTINATION share/applications)

=== helper/CMakeLists.txt ===
if (USE_QTERMWIDGET6)
  find_package(Qt6 REQUIRED COMPONENTS Core Network)
else()
  find_package(Qt5 REQUIRED COMPONENTS Core Network)
endif()

set(CMAKE_AUTOMOC ON)

set(src main.cpp octopihelper.cpp ../src/argumentlist.cpp)

set(header octopihelper.h ../src/argumentlist.h)

add_executable(octphelper ${src} ${header})
target_compile_definitions(octphelper PRIVATE QT_DEPRECATED_WARNINGS QT_USE_QSTRINGBUILDER QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_FROM_BYTEARRAY QT_NO_FOREACH)

if (USE_QTERMWIDGET6)
  target_include_directories(octphelper PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${Qt6Core_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS})
  target_link_libraries(octphelper PRIVATE Qt6::Core Qt6::Network)
else()
  target_include_directories(octphelper PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${Qt5Core_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
  target_link_libraries(octphelper PRIVATE Qt5::Core Qt5::Network)
endif()

install(TARGETS octphelper RUNTIME DESTINATION lib/octopi LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include)

=== notifier/CMakeLists.txt ===
option(USE_QTERMWIDGET6 "Build with qtermwidget6 instead of qtermwidget5" OFF)
option(USE_KF5NOTIFICATIONS "Build with KF5Notifications support" OFF)
option(USE_KF6NOTIFICATIONS "Build with KF6StatusNotifierItem support" OFF)

if (USE_QTERMWIDGET6)
  find_package(Qt6 REQUIRED COMPONENTS Core Core5Compat Xml Gui Widgets Network Multimedia)
  find_package(qtermwidget6 REQUIRED)
else()
  find_package(Qt5 REQUIRED COMPONENTS Core Xml Gui Widgets Network Multimedia)
  find_package(qtermwidget5 REQUIRED)
endif()

find_package(alpm_octopi_utils REQUIRED)

if (USE_KF5NOTIFICATIONS)
  find_package(KF5Notifications QUIET)
endif()  

if (USE_KF6NOTIFICATIONS)
  find_package(KF6StatusNotifierItem QUIET)
endif()

if(USE_KF5NOTIFICATIONS AND NOT KF5Notifications_FOUND)
    message(WARNING "KNotifications not found. Skipping")
endif()

if(USE_KF6NOTIFICATIONS AND NOT KF6StatusNotifierItem_FOUND)
    message(WARNING "KF6StatusNotifierItem not found. Skipping")
endif()

set(CMAKE_AUTOMOC ON)

set(src 
    main.cpp
    mainwindow.cpp
    outputdialog.cpp
    ../src/QtSolutions/qtsingleapplication.cpp
    ../src/QtSolutions/qtlocalpeer.cpp
    ../src/terminal.cpp
    ../src/unixcommand.cpp
    ../src/package.cpp
    ../src/wmhelper.cpp
    ../src/strconstants.cpp
    ../src/settingsmanager.cpp
    ../src/utils.cpp
    ../src/transactiondialog.cpp
    ../src/argumentlist.cpp
    ../src/pacmanexec.cpp
    ../src/searchlineedit.cpp
    ../src/searchbar.cpp
    ../src/optionsdialog.cpp
    ../src/termwidget.cpp
    ../src/aurvote.cpp
    ../src/qaesencryption.cpp
    ../src/alpmbackend.cpp)

set(header 
    mainwindow.h
    outputdialog.h
    ../src/QtSolutions/qtsingleapplication.h
    ../src/QtSolutions/qtlocalpeer.h
    ../src/uihelper.h
    ../src/terminal.h
    ../src/unixcommand.h
    ../src/wmhelper.h
    ../src/strconstants.h
    ../src/package.h
    ../src/utils.h
    ../src/transactiondialog.h
    ../src/argumentlist.h
    ../src/pacmanexec.h
    ../src/searchlineedit.h
    ../src/searchbar.h
    ../src/optionsdialog.h
    ../src/termwidget.h
    ../src/aurvote.h
    ../src/qaesencryption.h
    ../src/alpmbackend.h)

set(ui ../ui/transactiondialog.ui ../ui/optionsdialog.ui)

set(qrc ../resources.qrc)

qt_wrap_ui(src ${ui})
qt_add_resources(src ${qrc})

add_executable(octopi-notifier ${src} ${header})
target_compile_definitions(octopi-notifier PRIVATE OCTOPI_EXTENSIONS ALPM_BACKEND QT_USE_QSTRINGBUILDER QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_FROM_BYTEARRAY)

if (USE_QTERMWIDGET6)
  target_include_directories(octopi-notifier PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${Qt6Core_INCLUDE_DIRS} ${Qt6Xml_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS})
  target_link_libraries(octopi-notifier PRIVATE Qt6::Core Qt6::Xml Qt6::Gui Qt6::Widgets Qt6::Network Qt6::Multimedia qtermwidget6 alpm_octopi_utils)

  if(USE_KF6NOTIFICATIONS AND KF6StatusNotifierItem_FOUND)
    target_compile_definitions(octopi-notifier PRIVATE KSTATUS)
    find_package(Qt6 REQUIRED COMPONENTS DBus)
    target_include_directories(octopi-notifier PRIVATE ${Qt6DBus_INCLUDE_DIRS})
    target_link_libraries(octopi-notifier PRIVATE Qt6::DBus KF6::StatusNotifierItem)
  endif()
else()
  target_include_directories(octopi-notifier PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${Qt5Core_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
  target_link_libraries(octopi-notifier PRIVATE Qt5::Core Qt5::Xml Qt5::Gui Qt5::Widgets Qt5::Network Qt5::Multimedia qtermwidget5 alpm_octopi_utils)

  if(USE_KF5NOTIFICATIONS AND KF5Notifications_FOUND)
    target_compile_definitions(octopi-notifier PRIVATE KSTATUS)
    find_package(Qt5 REQUIRED COMPONENTS DBus)
    target_include_directories(octopi-notifier PRIVATE ${Qt5DBus_INCLUDE_DIRS})
    target_link_libraries(octopi-notifier PRIVATE Qt5::DBus KF5::Notifications)
  endif()
endif()

install(TARGETS octopi-notifier RUNTIME DESTINATION bin LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/octopi-notifier.desktop" DESTINATION share/applications)
#install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/octopi-notifier.desktop" DESTINATION /etc/xdg/autostart)

=== repoeditor/CMakeLists.txt ===
if (USE_QTERMWIDGET6)
  find_package(Qt6 REQUIRED COMPONENTS Core Gui Network Xml Widgets LinguistTools)
else()
  find_package(Qt5 REQUIRED COMPONENTS Core Gui Network Xml Widgets LinguistTools)
endif()

find_package(Threads REQUIRED)
find_library(UTIL_LIBRARY NAMES util)

set(CMAKE_AUTOMOC ON)

file(GLOB TS_FILES LIST_DIRECTORIES false "${CMAKE_CURRENT_LIST_DIR}/resources/translations/*.ts")
qt_add_translation(qmFiles ${TS_FILES})

set(src
    addrepo.cpp
    checkboxdelegate.cpp
    main.cpp
    optionsdelegate.cpp
    repoconf.cpp
    repoeditor.cpp
    repoentry.cpp
    ../src/qaesencryption.cpp
    ../src/unixcommand.cpp
    ../src/strconstants.cpp
    ../src/wmhelper.cpp
    ../src/terminal.cpp
    ../src/settingsmanager.cpp
    ../src/searchlineedit.cpp
    ../src/utils.cpp
    ../src/package.cpp
    ../src/QtSolutions/qtsingleapplication.cpp
    ../src/QtSolutions/qtlocalpeer.cpp
    #../src/QtSolutions/qtlockedfile.cpp
    ../src/QtSolutions/qtsinglecoreapplication.cpp)

set(header
    addrepo.h
    checkboxdelegate.h
    optionsdelegate.h
    repoconf.h
    repoeditor.h
    repoentry.h
    ../src/qaesencryption.h
    ../src/unixcommand.h
    ../src/strconstants.h
    ../src/wmhelper.h
    ../src/terminal.h
    ../src/settingsmanager.h
    ../src/searchlineedit.h
    ../src/utils.h
    ../src/package.h
    ../src/QtSolutions/qtsingleapplication.h
    ../src/QtSolutions/qtlocalpeer.h
    #../src/QtSolutions/qtlockedfile.h
    ../src/QtSolutions/qtsinglecoreapplication.h)

set(ui addrepo.ui repoeditor.ui)

set(qrc resources.qrc)

qt_wrap_ui(src ${ui})
qt_add_resources(src ${qrc})

add_executable(octopi-repoeditor ${src} ${header} ${qmFiles})
target_compile_definitions(octopi-repoeditor PRIVATE QT_USE_QSTRINGBUILDER QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_FROM_BYTEARRAY)

if (USE_QTERMWIDGET6)
  target_include_directories(octopi-repoeditor PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${Qt6Core_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Xml_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS})
  target_link_libraries(octopi-repoeditor PRIVATE Threads::Threads Qt6::Core Qt6::Gui Qt6::Network Qt6::Xml Qt6::Widgets ${UTIL_LIBRARY})
else()
  target_include_directories(octopi-repoeditor PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${Qt5Core_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS})
  target_link_libraries(octopi-repoeditor PRIVATE Threads::Threads Qt5::Core Qt5::Gui Qt5::Network Qt5::Xml Qt5::Widgets ${UTIL_LIBRARY})
endif()

install(TARGETS octopi-repoeditor RUNTIME DESTINATION bin LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/octopi-repoeditor.desktop" DESTINATION share/applications)

=== PKGBUILD ===
_pkgname=octopi
pkgname=octopi-git
pkgver=0.16.2.latest
pkgrel=1
pkgdesc="This is Octopi, a powerful Pacman frontend using Qt libs (git checkout)"
url="https://tintaescura.com/projects/octopi/"
arch=('i686' 'x86_64')
license=('GPL2')
depends=('alpm_octopi_utils' 'qtermwidget' 'sudo')
makedepends=('git')
groups=('system')
source=("git+https://github.com/aarnt/octopi.git")
md5sums=('SKIP')

prepare() {
   cd "${_pkgname}"
   cp resources/images/octopi_green.png resources/images/octopi.png
}

pkgver() {
   cd "${_pkgname}"
   git describe --long --tags --abbrev=7 | sed 's/\([^-]*-g\)/r\1/;s/-/./g;s/^v//'
}

build() {
   cd "${_pkgname}"
   echo "Starting build..."   
   qmake6 PREFIX=/usr QMAKE_CFLAGS="${CFLAGS}" QMAKE_CXXFLAGS="${CXXFLAGS}" QMAKE_LFLAGS="${LDFLAGS}" octopi.pro
   make

   _subdirs="cachecleaner helper notifier repoeditor"

   for _subdir in $_subdirs; do
     pushd $_subdir
     echo "Building octopi-$_subdir..."
     qmake6 PREFIX=/usr QMAKE_CFLAGS="${CFLAGS}" QMAKE_CXXFLAGS="${CXXFLAGS}" QMAKE_LFLAGS="${LDFLAGS}" "octopi-$_subdir.pro"
     make
     popd
   done  
}

package() {
   cd "${_pkgname}"
   make INSTALL_ROOT="${pkgdir}" install

   _subdirs="cachecleaner helper notifier repoeditor"

   for _subdir in $_subdirs; do
     pushd $_subdir
     make INSTALL_ROOT="${pkgdir}" install
     popd
   done   
}
